scriptname FGTConfigure extends SKI_ConfigBase

; SCRIPT VERSION ----------------------------------------------------------------------------------

int function GetVersion()
	return 2 ; Default version
endFunction


; PRIVATE VARIABLES -------------------------------------------------------------------------------

; OIDs (T:Text B:Toggle S:Slider M:Menu, C:Color, K:Key)
int TEXT_NOTIFICATION_B

int DEBUG_B

int ACCEPT_BOUNTY_QUEST_B

;int BOUNTY_REWARD_B

int ALLOW_ALL_NPC_B

int RESET_ALL_B

GlobalVariable property textNotification Auto

GlobalVariable property isDebug Auto

GlobalVariable property acceptBountyQuest Auto

;GlobalVariable property bountyReward Auto

GlobalVariable property allowAllNpc Auto

Quest property dialogue Auto

ReferenceAlias[] property bountyQuestActors Auto

bool resetAll

; State

; ...

; Internal

; ...


; INITIALIZATION ----------------------------------------------------------------------------------

; @implements SKI_ConfigBase
event OnConfigInit()
	{Called when this config menu is initialized}

	; ...
endEvent

; @implements SKI_QuestBase
event OnVersionUpdate(int a_version)
	{Called when a version update of this script has been detected}

	; ...
endEvent


; EVENTS ------------------------------------------------------------------------------------------

; @implements SKI_ConfigBase
event OnPageReset(string a_page)
	resetAll = false
	AddHeaderOption("Config")
	ACCEPT_BOUNTY_QUEST_B = AddToggleOption("Accept BountyQuest", acceptBountyQuest.getValueInt() == 1)
;	BOUNTY_REWARD_B = AddToggleOption("Bounty rewards can be obtained", bountyReward.getValueInt() == 1)
    TEXT_NOTIFICATION_B = AddToggleOption("Text notification", textNotification.getValueInt() == 1)

    ALLOW_ALL_NPC_B = AddToggleOption("Allow all NPC", allowAllNpc.getValueInt() == 1)
	RESET_ALL_B = AddToggleOption("Reset all NPC", false)

    DEBUG_B = AddToggleOption("Debug Text", isDebug.getValueInt() == 1)
endEvent

; @implements SKI_ConfigBase
event OnOptionHighlight(int a_option)
	{Called when highlighting an option}

	; ...
endEvent

; @implements SKI_ConfigBase
event OnOptionSelect(int a_option)
	if (a_option == ACCEPT_BOUNTY_QUEST_B)
		updateOptionValue(ACCEPT_BOUNTY_QUEST_B, acceptBountyQuest)
;	elseif (a_option == BOUNTY_REWARD)
;		updateOptionValue(BOUNTY_REWARD, bountyReward)
	elseif (a_option == TEXT_NOTIFICATION_B)
		updateOptionValue(TEXT_NOTIFICATION_B, textNotification)
	elseif (a_option == ALLOW_ALL_NPC_B)
		updateOptionValue(ALLOW_ALL_NPC_B, allowAllNpc)
	elseif (a_option == RESET_ALL_B)
		if (resetAll)
			resetAll = false
		else
			resetAll = true
		endif
		SetToggleOptionValue(RESET_ALL_B, resetAll)
	elseif (a_option == DEBUG_B)
		updateOptionValue(DEBUG_B, isDebug)
	endif
endEvent

function updateOptionValue(int i, GlobalVariable g)
	if (g.getValueInt() == 0)
		g.setValue(1)
	else
		g.setValue(0)
	endif
	SetToggleOptionValue(i, g.getValueInt())
endFunction


; @implements SKI_ConfigBase
event OnOptionDefault(int a_option)
	{Called when resetting an option to its default value}

	; ...
endEvent

; @implements SKI_ConfigBase
event OnOptionSliderOpen(int a_option)
	{Called when a slider option has been selected}

	; ...
endEvent

; @implements SKI_ConfigBase
event OnOptionSliderAccept(int a_option, float a_value)
	{Called when a new slider value has been accepted}

	; ...
endEvent

; @implements SKI_ConfigBase
event OnOptionMenuOpen(int a_option)
	{Called when a menu option has been selected}

	; ...
endEvent

; @implements SKI_ConfigBase
event OnOptionMenuAccept(int a_option, int a_index)
	{Called when a menu entry has been accepted}

	; ...
endEvent

; @implements SKI_ConfigBase
event OnOptionColorOpen(int a_option)
	{Called when a color option has been selected}

	; ...
endEvent

; @implements SKI_ConfigBase
event OnOptionColorAccept(int a_option, int a_color)
	{Called when a new color has been accepted}

	; ...
endEvent

; @implements SKI_ConfigBase
event OnOptionKeyMapChange(int a_option, int a_keyCode, string a_conflictControl, string a_conflictName)
	{Called when a key has been remapped}

	; ...
endEvent

event OnConfigClose()
	if (acceptBountyQuest.getValueInt() == 0)
		stopBountyQuests()
	endif
	if (resetAll)
		(dialogue as FGTDialogueQuest).resetAll()
		stopBountyQuests()
	endif
endEvent

function stopBountyQuests()
	int i = 0
	while (i < bountyQuestActors.length)
		Actor a = bountyQuestActors[i].getActorRef()
		bountyQuestActors[i].clear()
		bountyQuestActors[i].getOwningQuest().stop()
		if (a)
			a.enableAi(false)
			a.enableAi()
		endif
		i += 1
	endWhile
endFunction
