Scriptname FGTDialogueQuest extends Quest  

Faction property wandererFaction Auto

ReferenceAlias[] property actors Auto

Quest[] property quests Auto

function resetAll()
	int i = 0
	while (i < actors.length)
		if (actors[i])
			Actor a = actors[i].getActorReference()
			if (a)
				stopWander(a)
				a.moveToMyEditorLocation()
			endif
		endif
		i += 1
	endWhile
endFunction



function startup()
	Utility.wait(36.0)
	int i = 0
	while (i < actors.length)
		if (actors[i])
			Actor a = actors[i].getActorReference()
			if (a)
				if (quests[i].isRunning())
					quests[i].stop()
				endif
				quests[i].start()
				Utility.wait(0.5)
			endif
		endif
		i += 1
	endwhile
endFunction


function startWander(Actor a)
	if (setReference(a))
		a.addToFaction(wandererFaction)
	else
		Debug.notification("Can't do that anymore.")
		Debug.MessageBox("== Follower gose trip ==\nCan't do that anymore.")
	endif
endFunction

function stopWander(Actor a)
	a.removeFromFaction(wandererFaction)
	int i = 0
	while (i < actors.length)
		if (actors[i].getActorReference() == a)
			quests[i].stop()
			Utility.wait(0.5)
			actors[i].getOwningQuest().stop()
			return
		endif
		i += 1
	endwhile
endFunction


bool function setReference(Actor a)
	int i = 0
	while (i < actors.length)
		if (!actors[i].getReference())
			Quest q = actors[i].getOwningQuest()
			if (quests[i].isRunning())
				quests[i].stop()
			endif
			if (!q.isRunning())
				q.start()
				Utility.wait(0.5)
			endif
			actors[i].forceRefTo(a)
			Utility.wait(0.5)
			quests[i].start()
			a.enableAi(false)
			a.enableAi(true)
			return true
		endif
		i += 1
	endwhile
	return false
endFunction
