Scriptname FGTWandererScript extends ReferenceAlias  

Package property packageTemplate Auto

Faction property wandererFaction Auto

MiscObject Property gold Auto

GlobalVariable property acceptBountyQuest Auto

GlobalVariable property textNotification Auto

GlobalVariable property isDebug Auto

Package markerPackage

ReferenceAlias[] property bountyQuestActors Auto

Quest[] property bountyQuests Auto

Keyword[] property keywords Auto

Quest property dialogue Auto

Event OnPackageStart(Package akPackage)
  Package templete = akPackage.GetTemplate()
  if (templete && templete == packageTemplate)
    markerPackage = akPackage
  endif
endEvent

bool function locationHasKeywords(Location loc)
  int i = 0
  while (i < keywords.length)
    if (loc.hasKeyword(keywords[i]))
      return true
    endif
    i += 1
  endWhile
  return false
endFunction

function startBountyQuest()
  int i = 0
  while (i < bountyQuests.length)
    if (bountyQuests[i].isRunning() && bountyQuests[i].getStage() != 10)
      bountyQuests[i].setStage(10)
      return
    endif
    i += 1
  endWhile
endFunction


Event OnLocationChange(Location akOldLoc, Location akNewLoc)
  if (!akOldLoc || !akNewLoc)
    return
  endif
  Actor a = getActorReference()
  if (SKSE.GetVersionRelease() > 0)
    String name = akNewLoc.getName()
    if (name && isDebug.getValueInt() == 1)
Debug.notification(a.getBaseObject().getName() + " in " + name)
    endif
  endif
  if (acceptBountyQuest.getValueInt() == 1 && akOldLoc && locationHasKeywords(akOldLoc))
    assignBountyQuest()
  endif
endEvent

    


function assignBountyQuest()
  int i = 0
  while (i < bountyQuestActors.length)
    Quest q =  bountyQuestActors[i].getOwningQuest()
    if (bountyQuests[i].isRunning() && bountyQuests[i].getStage() >= 10 && !q.isRunning())
      if (q.start())
        Actor a = getActorReference()
        if (bountyQuestActors[i].forceRefIfEmpty(a))
          if (SKSE.GetVersionRelease() > 0)
            if (textNotification.getValueInt() == 1)
Debug.notification(a.GetBaseObject().getName() + " has accepted the BountyQuest.")          
            endif
          endif
          getOwningQuest().stop()
          getOwningQuest().start()
          a.enableAI(false)
          a.enableAI()
        endif
      endif
    endif
    i += 1
  endWhile
endFunction


bool function isAssigned()
  int i = 0
  while (i < bountyQuestActors.length)
    if (bountyQuestActors[i].getActorRef() == getActorRef())
      return true
    endif
    i += 1
  endWhile
  return false
endFunction

Event OnPackageEnd(Package akOldPackage)
  if (markerPackage && akOldPackage == markerPackage)
    Quest q = akOldPackage.getOwningQuest()
    Actor a = getActorReference()
    a.additem(gold, Utility.RandomInt(1, 12), true)
    q.stop()
    q.start()
    a.enableAI(false)
    a.enableAI()
  endif
endEvent



Event OnDeath(Actor akKiller)
  int i = 0
  Actor a = getActorReference()
  while (i < bountyQuestActors.length)
    if (bountyQuestActors[i].getActorRef() == a)
      bountyQuestActors[i].clear()
      bountyQuestActors[i].getOwningQuest().stop()
    endif
    i += 1
  endWhile
  (dialogue as FGTDialogueQuest).stopWander(a)
endEvent
